diff --git a/src/util-spm-bm.h b/src/util-spm-bm.h
index 8496407..6864a53 100644
--- a/src/util-spm-bm.h
+++ b/src/util-spm-bm.h
@@ -6,14 +6,252 @@
 
 #define ALPHABET_SIZE 256
 
-inline void PreBmBc(const uint8_t *x, int32_t m, int32_t *bmBc);
-inline void BoyerMooreSuffixes(const uint8_t *x, int32_t m, int32_t *suff);
-inline void PreBmGs(const uint8_t *x, int32_t m, int32_t *bmGs);
-inline uint8_t *BoyerMoore(uint8_t *x, int32_t m, uint8_t *y, int32_t n, int32_t *bmGs, int32_t *bmBc);
-inline void PreBmBcNocase(const uint8_t *x, int32_t m, int32_t *bmBc);
-inline void BoyerMooreSuffixesNocase(const uint8_t *x, int32_t m, int32_t *suff);
-inline void PreBmGsNocase(const uint8_t *x, int32_t m, int32_t *bmGs);
-inline uint8_t *BoyerMooreNocase(uint8_t *x, int32_t m, uint8_t *y, int32_t n, int32_t *bmGs, int32_t *bmBc);
+static inline void PreBmBc(const uint8_t *x, int32_t m, int32_t *bmBc);
+static inline void BoyerMooreSuffixes(const uint8_t *x, int32_t m, int32_t *suff);
+static inline void PreBmGs(const uint8_t *x, int32_t m, int32_t *bmGs);
+static inline uint8_t *BoyerMoore(uint8_t *x, int32_t m, uint8_t *y, int32_t n, int32_t *bmGs, int32_t *bmBc);
+static inline void PreBmBcNocase(const uint8_t *x, int32_t m, int32_t *bmBc);
+static inline void BoyerMooreSuffixesNocase(const uint8_t *x, int32_t m, int32_t *suff);
+static inline void PreBmGsNocase(const uint8_t *x, int32_t m, int32_t *bmGs);
+static inline uint8_t *BoyerMooreNocase(uint8_t *x, int32_t m, uint8_t *y, int32_t n, int32_t *bmGs, int32_t *bmBc);
+
+/** --------- Inline functions -------- */
+
+
+/**
+ * \brief Array setup function for bad characters that split the pattern
+ *        Remember that the result array should be the length of ALPHABET_SIZE
+ *
+ * \param str pointer to the pattern string
+ * \param size length of the string
+ * \param result pointer to an empty array that will hold the badchars
+ */
+inline void PreBmBc(const uint8_t *x, int32_t m, int32_t *bmBc) {
+    int32_t i;
+
+    for (i = 0; i < 256; ++i) {
+        bmBc[i] = m;
+    }
+    for (i = 0; i < m - 1; ++i) {
+        bmBc[(unsigned char)x[i]] = m - i - 1;
+    }
+}
+
+/**
+ * \brief Array setup function for building prefixes (shift for valid prefixes) for boyermoore context
+ *
+ * \param x pointer to the pattern string
+ * \param m length of the string
+ * \param suff pointer to an empty array that will hold the prefixes (shifts)
+ */
+inline void BoyerMooreSuffixes(const uint8_t *x, int32_t m, int32_t *suff) {
+    int32_t f = 0, g, i;
+    suff[m - 1] = m;
+    g = m - 1;
+    for (i = m - 2; i >= 0; --i) {
+        if (i > g && suff[i + m - 1 - f] < i - g)
+            suff[i] = suff[i + m - 1 - f];
+        else {
+            if (i < g)
+                g = i;
+            f = i;
+            while (g >= 0 && x[g] == x[g + m - 1 - f])
+                --g;
+            suff[i] = f - g;
+        }
+    }
+}
+
+/**
+ * \brief Array setup function for building prefixes (shift for valid prefixes) for boyermoore context
+ *
+ * \param x pointer to the pattern string
+ * \param m length of the string
+ * \param bmGs pointer to an empty array that will hold the prefixes (shifts)
+ */
+inline void PreBmGs(const uint8_t *x, int32_t m, int32_t *bmGs) {
+    int32_t i, j;
+    int32_t *suff;
+
+    suff = SCMalloc(sizeof(int32_t) * (m + 1));
+
+    BoyerMooreSuffixes(x, m, suff);
+
+    for (i = 0; i < m; ++i)
+        bmGs[i] = m;
+
+    j = 0;
+
+    for (i = m - 1; i >= -1; --i)
+        if (i == -1 || suff[i] == i + 1)
+            for (; j < m - 1 - i; ++j)
+                if (bmGs[j] == m)
+                    bmGs[j] = m - 1 - i;
+
+    for (i = 0; i <= m - 2; ++i)
+        bmGs[m - 1 - suff[i]] = m - 1 - i;
+    SCFree(suff);
+}
+
+/**
+ * \brief Array setup function for bad characters that split the pattern
+ *        Remember that the result array should be the length of ALPHABET_SIZE
+ *
+ * \param str pointer to the pattern string
+ * \param size length of the string
+ * \param result pointer to an empty array that will hold the badchars
+ */
+inline void PreBmBcNocase(const uint8_t *x, int32_t m, int32_t *bmBc) {
+    int32_t i;
+
+    for (i = 0; i < 256; ++i) {
+        bmBc[i] = m;
+    }
+    for (i = 0; i < m - 1; ++i) {
+        bmBc[u8_tolower((unsigned char)x[i])] = m - 1 - i;
+    }
+}
+
+inline void BoyerMooreSuffixesNocase(const uint8_t *x, int32_t m, int32_t *suff) {
+    int32_t f = 0, g, i;
+
+    suff[m - 1] = m;
+    g = m - 1;
+    for (i = m - 2; i >= 0; --i) {
+        if (i > g && suff[i + m - 1 - f] < i - g) {
+            suff[i] = suff[i + m - 1 - f];
+        } else {
+            if (i < g) {
+                g = i;
+            }
+            f = i;
+            while (g >= 0 && u8_tolower(x[g]) == u8_tolower(x[g + m - 1 - f])) {
+                --g;
+            }
+            suff[i] = f - g;
+        }
+    }
+}
+
+/**
+ * \brief Array setup function for building prefixes (shift for valid prefixes)
+ *        for boyermoore context case less
+ *
+ * \param x pointer to the pattern string
+ * \param m length of the string
+ * \param bmGs pointer to an empty array that will hold the prefixes (shifts)
+ */
+inline void PreBmGsNocase(const uint8_t *x, int32_t m, int32_t *bmGs) {
+    int32_t i, j;
+    int32_t* suff;
+
+    suff = SCMalloc(sizeof(int32_t) * (m + 1));
+
+    BoyerMooreSuffixesNocase(x, m, suff);
+
+    for (i = 0; i < m; ++i) {
+        bmGs[i] = m;
+    }
+    j = 0;
+    for (i = m - 1; i >= 0; --i) {
+        if (i == -1 || suff[i] == i + 1) {
+            for (; j < m - 1 - i; ++j) {
+                if (bmGs[j] == m) {
+                    bmGs[j] = m - 1 - i;
+                }
+            }
+        }
+    }
+    for (i = 0; i <= m - 2; ++i) {
+        bmGs[m - 1 - suff[i]] = m - 1 - i;
+    }
+
+    SCFree(suff);
+}
+
+/**
+ * \brief Boyer Moore search algorithm
+ *        Is better as the pattern length increases and for big buffers to search in.
+ *        The algorithm needs a context of two arrays already prepared
+ *        by prep_bad_chars() and prep_good_suffix()
+ *
+ * \param y pointer to the buffer to search in
+ * \param n length limit of the buffer
+ * \param x pointer to the pattern we ar searching for
+ * \param m length limit of the needle
+ * \param bmBc pointer to an array of BoyerMooreSuffixes prepared by prep_good_suffix()
+ * \param bmGs pointer to an array of bachars prepared by prep_bad_chars()
+ *
+ * \retval ptr to start of the match; NULL if no match
+ */
+inline uint8_t *BoyerMoore(uint8_t *x, int32_t m, uint8_t *y, int32_t n, int32_t *bmGs, int32_t *bmBc) {
+   int i, j, m1, m2;
+#if 0
+    printf("\nBad:\n");
+    for (i=0;i<ALPHABET_SIZE;i++)
+        printf("%c,%d ", i, bmBc[i]);
+
+    printf("\ngood:\n");
+    for (i=0;i<m;i++)
+        printf("%c, %d ", x[i],bmBc[i]);
+    printf("\n");
+#endif
+   j = 0;
+   while (j <= n - m ) {
+      for (i = m - 1; i >= 0 && x[i] == y[i + j]; --i);
+
+      if (i < 0) {
+         return y + j;
+         j += bmGs[0];
+      } else {
+ //        printf("%c", y[i+j]);
+         j += (m1 = bmGs[i]) > (m2 = bmBc[y[i + j]] - m + 1 + i)? m1: m2;
+//            printf("%d, %d\n", m1, m2);
+      }
+   }
+   return NULL;
+}
+
+
+/**
+ * \brief Boyer Moore search algorithm
+ *        Is better as the pattern length increases and for big buffers to search in.
+ *        The algorithm needs a context of two arrays already prepared
+ *        by prep_bad_chars() and prep_good_suffix()
+ *
+ * \param y pointer to the buffer to search in
+ * \param n length limit of the buffer
+ * \param x pointer to the pattern we ar searching for
+ * \param m length limit of the needle
+ * \param bmBc pointer to an array of BoyerMooreSuffixes prepared by prep_good_suffix()
+ * \param bmGs pointer to an array of bachars prepared by prep_bad_chars()
+ *
+ * \retval ptr to start of the match; NULL if no match
+ */
+inline uint8_t *BoyerMooreNocase(uint8_t *x, int32_t m, uint8_t *y, int32_t n, int32_t *bmGs, int32_t *bmBc) {
+    int i, j, m1, m2;
+#if 0
+    printf("\nBad:\n");
+    for (i=0;i<ALPHABET_SIZE;i++)
+        printf("%c,%d ", i, bmBc[i]);
+
+    printf("\ngood:\n");
+    for (i=0;i<m;i++)
+        printf("%c, %d ", x[i],bmBc[i]);
+    printf("\n");
+#endif
+    j = 0;
+    while (j <= n - m ) {
+        for (i = m - 1; i >= 0 && u8_tolower(x[i]) == u8_tolower(y[i + j]); --i);
+
+        if (i < 0) {
+            return y + j;
+        } else {
+            j += (m1=bmGs[i]) > (m2=bmBc[u8_tolower(y[i + j])] - m + 1 + i)?m1:m2;
+        }
+   }
+   return NULL;
+}
 
 #endif /* __UTIL_SPM_BM__ */
 
diff --git a/src/util-spm-bs.c b/src/util-spm-bs.c
index e775aaa..e0f1e3c 100644
--- a/src/util-spm-bs.c
+++ b/src/util-spm-bs.c
@@ -17,92 +17,4 @@
 #include <limits.h>
 #include <string.h>
 
-/**
- * \brief Basic search improved. Limits are better handled, so
- * it doesn't start searches that wont fit in the remaining buffer
- *
- * \param haystack pointer to the buffer to search in
- * \param haystack_len length limit of the buffer
- * \param neddle pointer to the pattern we ar searching for
- * \param needle_len length limit of the needle
- *
- * \retval ptr to start of the match; NULL if no match
- */
-inline uint8_t *BasicSearch(const uint8_t *haystack, uint32_t haystack_len, const uint8_t *needle, uint32_t needle_len) {
-    const uint8_t *h, *n;
-    const uint8_t *hmax = haystack + haystack_len;
-    const uint8_t *nmax = needle + needle_len;
-
-    if (needle_len == 0 || needle_len > haystack_len)
-        return NULL;
-
-    for (n = needle; nmax - n <= hmax - haystack; haystack++) {
-        if (*haystack != *n) {
-            continue;
-        }
-        /* one byte needles */
-        if (needle_len == 1)
-            return (uint8_t *)haystack;
-
-        for (h = haystack+1, n++; nmax - n <= hmax - haystack; h++, n++) {
-            if (*h != *n) {
-                break;
-            }
-            /* if we run out of needle we fully matched */
-            if (n == nmax - 1) {
-                return (uint8_t *)haystack;
-            }
-        }
-        n = needle;
-    }
-
-    return NULL;
-}
-
-/**
- * \brief Basic search case less
- *
- * \param haystack pointer to the buffer to search in
- * \param haystack_len length limit of the buffer
- * \param neddle pointer to the pattern we ar searching for
- * \param needle_len length limit of the needle
- *
- * \retval ptr to start of the match; NULL if no match
- */
-inline uint8_t *BasicSearchNocase(const uint8_t *haystack, uint32_t haystack_len, const uint8_t *needle, uint32_t needle_len) {
-    const uint8_t *h, *n;
-    const uint8_t *hmax = haystack + haystack_len;
-    const uint8_t *nmax = needle + needle_len;
-
-    if (needle_len == 0 || needle_len > haystack_len)
-        return NULL;
-
-    n = needle;
-    for (n = needle; nmax - n <= hmax - haystack; haystack++) {
-        if (u8_tolower(*haystack) != u8_tolower(*n)) {
-            continue;
-        }
-        /* one byte needles */
-        if (needle_len == 1) {
-            return (uint8_t *)haystack;
-        }
-
-        for (h = haystack+1, n++; nmax - n <= hmax - h ; h++, n++) {
-            if (u8_tolower(*h) != u8_tolower(*n)) {
-                break;
-            }
-            /* if we run out of needle we fully matched */
-            if (n == nmax - 1) {
-                return (uint8_t *)haystack;
-            }
-        }
-        n = needle;
-    }
-
-    return NULL;
-}
-
-inline void BasicSearchInit (void) {
-    /* nothing no more */
-}
-
+/* Look at the .h, all the functions are Inlined */
diff --git a/src/util-spm-bs.h b/src/util-spm-bs.h
index 6bb3afb..614f60f 100644
--- a/src/util-spm-bs.h
+++ b/src/util-spm-bs.h
@@ -3,10 +3,100 @@
 
 #include "suricata-common.h"
 #include "suricata.h"
+/** ----- Inline functions ------- */
+static inline uint8_t *BasicSearch(const uint8_t *, uint32_t, const uint8_t *, uint32_t);
+static inline uint8_t *BasicSearchNocase(const uint8_t *, uint32_t, const uint8_t *, uint32_t);
+static inline void BasicSearchInit (void);
+
+/**
+ * \brief Basic search improved. Limits are better handled, so
+ * it doesn't start searches that wont fit in the remaining buffer
+ *
+ * \param haystack pointer to the buffer to search in
+ * \param haystack_len length limit of the buffer
+ * \param neddle pointer to the pattern we ar searching for
+ * \param needle_len length limit of the needle
+ *
+ * \retval ptr to start of the match; NULL if no match
+ */
+static inline uint8_t *BasicSearch(const uint8_t *haystack, uint32_t haystack_len, const uint8_t *needle, uint32_t needle_len) {
+    const uint8_t *h, *n;
+    const uint8_t *hmax = haystack + haystack_len;
+    const uint8_t *nmax = needle + needle_len;
+
+    if (needle_len == 0 || needle_len > haystack_len)
+        return NULL;
+
+    for (n = needle; nmax - n <= hmax - haystack; haystack++) {
+        if (*haystack != *n) {
+            continue;
+        }
+        /* one byte needles */
+        if (needle_len == 1)
+            return (uint8_t *)haystack;
+
+        for (h = haystack+1, n++; nmax - n <= hmax - haystack; h++, n++) {
+            if (*h != *n) {
+                break;
+            }
+            /* if we run out of needle we fully matched */
+            if (n == nmax - 1) {
+                return (uint8_t *)haystack;
+            }
+        }
+        n = needle;
+    }
+
+    return NULL;
+}
+
+/**
+ * \brief Basic search case less
+ *
+ * \param haystack pointer to the buffer to search in
+ * \param haystack_len length limit of the buffer
+ * \param neddle pointer to the pattern we ar searching for
+ * \param needle_len length limit of the needle
+ *
+ * \retval ptr to start of the match; NULL if no match
+ */
+static inline uint8_t *BasicSearchNocase(const uint8_t *haystack, uint32_t haystack_len, const uint8_t *needle, uint32_t needle_len) {
+    const uint8_t *h, *n;
+    const uint8_t *hmax = haystack + haystack_len;
+    const uint8_t *nmax = needle + needle_len;
+
+    if (needle_len == 0 || needle_len > haystack_len)
+        return NULL;
+
+    n = needle;
+    for (n = needle; nmax - n <= hmax - haystack; haystack++) {
+        if (u8_tolower(*haystack) != u8_tolower(*n)) {
+            continue;
+        }
+        /* one byte needles */
+        if (needle_len == 1) {
+            return (uint8_t *)haystack;
+        }
+
+        for (h = haystack+1, n++; nmax - n <= hmax - h ; h++, n++) {
+            if (u8_tolower(*h) != u8_tolower(*n)) {
+                break;
+            }
+            /* if we run out of needle we fully matched */
+            if (n == nmax - 1) {
+                return (uint8_t *)haystack;
+            }
+        }
+        n = needle;
+    }
+
+    return NULL;
+}
+
+static inline void BasicSearchInit (void) {
+    /* nothing no more */
+}
 
-inline uint8_t *BasicSearch(const uint8_t *, uint32_t, const uint8_t *, uint32_t);
-inline uint8_t *BasicSearchNocase(const uint8_t *, uint32_t, const uint8_t *, uint32_t);
-inline void BasicSearchInit (void);
 
 #endif /* __UTIL_SPM_BS__ */
 
diff --git a/src/util-spm-bs2bm.c b/src/util-spm-bs2bm.c
index 552e843..3537a4a 100644
--- a/src/util-spm-bs2bm.c
+++ b/src/util-spm-bs2bm.c
@@ -16,144 +16,4 @@
 #include <limits.h>
 #include <string.h>
 
-/**
- * \brief Array setup function for Bs2Bm of bad characters index (not found at the needle)
- *
- * \param neddle pointer to the pattern we ar searching for
- * \param needle_len length limit of the needle
- * \param badchars pointer to an empty array of bachars. The array prepared contains
- *                 characters that can't be inside the needle_len. So the skips can be
- *                 faster
- */
-inline void Bs2BmBadchars(const uint8_t *needle, uint32_t needle_len, uint8_t *badchars) {
-    uint32_t i;
-    for (i = 0; i < ALPHABET_SIZE; i++)
-        badchars[i] = 1;
-
-    /* set to 0 the values where index as ascii is present
-     * because they are not badchars
-     */
-    for (i = 0; i < needle_len; i++)
-        badchars[needle[i]] = 0;
-}
-
-/**
- * \brief Array setup function for Bs2BmNocase of bad characters index (not found at the needle)
- *
- * \param neddle pointer to the pattern we ar searching for
- * \param needle_len length limit of the needle
- * \param badchars pointer to an empty array of bachars. The array prepared contains
- *                 characters that can't be inside the needle_len. So the skips can be
- *                 faster
- */
-inline void Bs2BmBadcharsNocase(const uint8_t *needle, uint32_t needle_len, uint8_t *badchars) {
-    uint32_t i;
-    for (i = 0; i < ALPHABET_SIZE; i++)
-        badchars[i] = 1;
-
-    /* set to 0 the values where index as ascii is present
-     * because they are not badchars
-     */
-    for (i = 0; i < needle_len; i++) {
-        badchars[u8_tolower(needle[i])] = 0;
-    }
-}
-
-
-/**
- * \brief Basic search with a bad characters array. The array badchars contains
- *        flags at character's ascii index that can't be inside the needle. So the skips can be
- *        faster
- *
- * \param haystack pointer to the buffer to search in
- * \param haystack_len length limit of the buffer
- * \param neddle pointer to the pattern we ar searching for
- * \param needle_len length limit of the needle
- * \param badchars pointer to an array of bachars prepared by Bs2BmBadchars()
- *
- * \retval ptr to start of the match; NULL if no match
- */
-inline uint8_t * Bs2Bm(const uint8_t *haystack, uint32_t haystack_len, const uint8_t *needle, uint32_t needle_len, uint8_t badchars[])
-{
-    const uint8_t *h, *n;
-    const uint8_t *hmax = haystack + haystack_len;
-    const uint8_t *nmax = needle + needle_len;
-
-    if (needle_len == 0 || needle_len > haystack_len)
-        return NULL;
-
-    for (n = needle; nmax - n <= hmax - haystack; haystack++) {
-        if (*haystack != *n) {
-            continue;
-        }
-        /* one byte needles */
-        if (needle_len == 1)
-            return (uint8_t *)haystack;
-
-        for (h = haystack+1, n++; nmax - n <= hmax - haystack; h++, n++) {
-            if (*h != *n) {
-                if (badchars[*h] == 1) {
-                    /* skip it! */
-                    haystack = h;
-                }
-                break;
-            }
-            /* if we run out of needle we fully matched */
-            if (n == nmax - 1 ) {
-                return (uint8_t *)haystack;
-            }
-        }
-        n = needle;
-    }
-
-    return NULL;
-}
-
-/**
- * \brief Basic search case less with a bad characters array. The array badchars contains
- *        flags at character's ascii index that can't be inside the needle. So the skips can be
- *        faster
- *
- * \param haystack pointer to the buffer to search in
- * \param haystack_len length limit of the buffer
- * \param neddle pointer to the pattern we ar searching for
- * \param needle_len length limit of the needle
- * \param badchars pointer to an array of bachars prepared by Bs2BmBadchars()
- *
- * \retval ptr to start of the match; NULL if no match
- */
-inline uint8_t *Bs2BmNocase(const uint8_t *haystack, uint32_t haystack_len, const uint8_t *needle, uint32_t needle_len, uint8_t badchars[])
-{
-    const uint8_t *h, *n;
-    const uint8_t *hmax = haystack + haystack_len;
-    const uint8_t *nmax = needle + needle_len;
-
-    if (needle_len == 0 || needle_len > haystack_len)
-        return NULL;
-
-    for (n = needle; nmax - n <= hmax - haystack; haystack++) {
-        if (u8_tolower(*haystack) != u8_tolower(*n)) {
-            continue;
-        }
-        /* one byte needles */
-        if (needle_len == 1)
-            return (uint8_t *)haystack;
-
-        for (h = haystack+1, n++; nmax - n <= hmax - haystack; h++, n++) {
-            if (u8_tolower(*h) != u8_tolower(*n)) {
-                if (badchars[u8_tolower(*h)] == 1) {
-                    /* skip it! */
-                    haystack = h;
-                }
-                break;
-            }
-            /* if we run out of needle we fully matched */
-            if (n == nmax - 1) {
-                return (uint8_t *)haystack;
-            }
-        }
-        n = needle;
-    }
-
-    return NULL;
-}
+/* Look at the .h, all the functions are Inline */
diff --git a/src/util-spm-bs2bm.h b/src/util-spm-bs2bm.h
index 5ec6806..3784cee 100644
--- a/src/util-spm-bs2bm.h
+++ b/src/util-spm-bs2bm.h
@@ -6,10 +6,153 @@
 
 #define ALPHABET_SIZE 256
 
-inline void Bs2BmBadchars(const uint8_t *, uint32_t, uint8_t *);
-inline void Bs2BmBadcharsNocase(const uint8_t *, uint32_t, uint8_t *);
-inline uint8_t * Bs2Bm(const uint8_t *, uint32_t, const uint8_t *, uint32_t, uint8_t []);
-inline uint8_t *Bs2BmNocase(const uint8_t *, uint32_t, const uint8_t *, uint32_t, uint8_t []);
+/** ----- Inline funcions ------ */
 
+static inline void Bs2BmBadchars(const uint8_t *, uint32_t, uint8_t *);
+static inline void Bs2BmBadcharsNocase(const uint8_t *, uint32_t, uint8_t *);
+static inline uint8_t * Bs2Bm(const uint8_t *, uint32_t, const uint8_t *, uint32_t, uint8_t []);
+static inline uint8_t *Bs2BmNocase(const uint8_t *, uint32_t, const uint8_t *, uint32_t, uint8_t []);
+
+/**
+ * \brief Array setup function for Bs2Bm of bad characters index (not found at the needle)
+ *
+ * \param neddle pointer to the pattern we ar searching for
+ * \param needle_len length limit of the needle
+ * \param badchars pointer to an empty array of bachars. The array prepared contains
+ *                 characters that can't be inside the needle_len. So the skips can be
+ *                 faster
+ */
+static inline void Bs2BmBadchars(const uint8_t *needle, uint32_t needle_len, uint8_t *badchars) {
+    uint32_t i;
+    for (i = 0; i < ALPHABET_SIZE; i++)
+        badchars[i] = 1;
+
+    /* set to 0 the values where index as ascii is present
+     * because they are not badchars
+     */
+    for (i = 0; i < needle_len; i++)
+        badchars[needle[i]] = 0;
+}
+
+/**
+ * \brief Array setup function for Bs2BmNocase of bad characters index (not found at the needle)
+ *
+ * \param neddle pointer to the pattern we ar searching for
+ * \param needle_len length limit of the needle
+ * \param badchars pointer to an empty array of bachars. The array prepared contains
+ *                 characters that can't be inside the needle_len. So the skips can be
+ *                 faster
+ */
+static inline void Bs2BmBadcharsNocase(const uint8_t *needle, uint32_t needle_len, uint8_t *badchars) {
+    uint32_t i;
+    for (i = 0; i < ALPHABET_SIZE; i++)
+        badchars[i] = 1;
+
+    /* set to 0 the values where index as ascii is present
+     * because they are not badchars
+     */
+    for (i = 0; i < needle_len; i++) {
+        badchars[u8_tolower(needle[i])] = 0;
+    }
+}
+
+
+/**
+ * \brief Basic search with a bad characters array. The array badchars contains
+ *        flags at character's ascii index that can't be inside the needle. So the skips can be
+ *        faster
+ *
+ * \param haystack pointer to the buffer to search in
+ * \param haystack_len length limit of the buffer
+ * \param neddle pointer to the pattern we ar searching for
+ * \param needle_len length limit of the needle
+ * \param badchars pointer to an array of bachars prepared by Bs2BmBadchars()
+ *
+ * \retval ptr to start of the match; NULL if no match
+ */
+static inline uint8_t * Bs2Bm(const uint8_t *haystack, uint32_t haystack_len, const uint8_t *needle, uint32_t needle_len, uint8_t badchars[])
+{
+    const uint8_t *h, *n;
+    const uint8_t *hmax = haystack + haystack_len;
+    const uint8_t *nmax = needle + needle_len;
+
+    if (needle_len == 0 || needle_len > haystack_len)
+        return NULL;
+
+    for (n = needle; nmax - n <= hmax - haystack; haystack++) {
+        if (*haystack != *n) {
+            continue;
+        }
+        /* one byte needles */
+        if (needle_len == 1)
+            return (uint8_t *)haystack;
+
+        for (h = haystack+1, n++; nmax - n <= hmax - haystack; h++, n++) {
+            if (*h != *n) {
+                if (badchars[*h] == 1) {
+                    /* skip it! */
+                    haystack = h;
+                }
+                break;
+            }
+            /* if we run out of needle we fully matched */
+            if (n == nmax - 1 ) {
+                return (uint8_t *)haystack;
+            }
+        }
+        n = needle;
+    }
+
+    return NULL;
+}
+
+/**
+ * \brief Basic search case less with a bad characters array. The array badchars contains
+ *        flags at character's ascii index that can't be inside the needle. So the skips can be
+ *        faster
+ *
+ * \param haystack pointer to the buffer to search in
+ * \param haystack_len length limit of the buffer
+ * \param neddle pointer to the pattern we ar searching for
+ * \param needle_len length limit of the needle
+ * \param badchars pointer to an array of bachars prepared by Bs2BmBadchars()
+ *
+ * \retval ptr to start of the match; NULL if no match
+ */
+static inline uint8_t *Bs2BmNocase(const uint8_t *haystack, uint32_t haystack_len, const uint8_t *needle, uint32_t needle_len, uint8_t badchars[])
+{
+    const uint8_t *h, *n;
+    const uint8_t *hmax = haystack + haystack_len;
+    const uint8_t *nmax = needle + needle_len;
+
+    if (needle_len == 0 || needle_len > haystack_len)
+        return NULL;
+
+    for (n = needle; nmax - n <= hmax - haystack; haystack++) {
+        if (u8_tolower(*haystack) != u8_tolower(*n)) {
+            continue;
+        }
+        /* one byte needles */
+        if (needle_len == 1)
+            return (uint8_t *)haystack;
+
+        for (h = haystack+1, n++; nmax - n <= hmax - haystack; h++, n++) {
+            if (u8_tolower(*h) != u8_tolower(*n)) {
+                if (badchars[u8_tolower(*h)] == 1) {
+                    /* skip it! */
+                    haystack = h;
+                }
+                break;
+            }
+            /* if we run out of needle we fully matched */
+            if (n == nmax - 1) {
+                return (uint8_t *)haystack;
+            }
+        }
+        n = needle;
+    }
+
+    return NULL;
+}
 #endif /* __UTIL_SPM_BS2BM__ */
 
